#include "FluggNavigator.hh"
#include "G4ios.hh"
#include <iomanip>

#define G4DEBUG_NAVIGATION 1
#define G4VERBOSE 1

FluggNavigator::FluggNavigator() : 
  G4Navigator()
{
  G4cout << "==> Flugg FluggNavigator constructor" << G4endl;
  G4cout << "\t+fHistory=" << fHistory << ") ..." << G4endl;
  ResetStackAndState();
  G4cout << "<== Flugg FluggNavigator constructor" << G4endl;
}

void FluggNavigator::UpdateNavigatorHistory(const G4NavigationHistory* newNavHistory)
{
#ifdef G4GEOMETRY_DEBUG
 G4cout << "==> Flugg FluggNavigator::UpdateNavigatorHistory(" << newNavHistory 
       << ")" << G4endl;
  G4cout << "\t+fHistory=" << fHistory << ") ..." << G4endl;
#endif
  ResetStackAndState();
  fHistory = *newNavHistory;
  SetupHierarchy();
#ifdef G4GEOMETRY_DEBUG
  G4cout << "<== Flugg FluggNavigator::UpdateNavigatorHistory(" << newNavHistory 
       << ")" << G4endl;
#endif
}
